#include<stdio.h>

int zadA(int x) {
  int i;
  if (x < 0) return zadA(17 - x);
  if (x < 2) return zadA(17 + x);
  for (i = x - 1; i > 2; --i) if (!(x % i)) return zadA(i);
  return x;
}

int zadB(int x) {
  int p = 1, s = 0, n = 0;
  if (x > -10 && x < 10) return x;
  if (x < 0) x = -x;
  while (x > 0) {
    p *= (x % 10);
    s += (x % 10);
    x /= 10;
    ++n;
  }
  return zadB(n % 2 ? p : s);
}

int zadC(int x) {
  int s = 0, ox = x;
  if (x < 0) x = -x;
  if (x < 16) return zadC(6 * x + 1);
  while (x > 0) {
    if (x % 16 > 9) return ox;
    s += x % 16;
    x /= 16;
  }
  return zadC(s)+1;
}

int zadD(int x) {
  int aps_x = (x < 0 ? -x : x), zadnje_dvije = aps_x % 9;
  if (aps_x >= 27 && aps_x < 81) return x;
  if (aps_x < 27) return zadD(243 + x + 1);
  if (zadnje_dvije == 0 || zadnje_dvije == 4 || zadnje_dvije == 8) return zadD(aps_x / 2);
  return zadD(x - 17);
}

void line(void) {
  int i;
  printf("+-----+");
  for (i = 0; i < 4; ++i) printf("-------------+");
  printf("\n");
}

#define max 320

int main(void) {
  int i;
  line();
  printf("|  x  | %11s | %11s | %11s | %11s |\n", "zadA(x)", "zadB(x)", "zadC(x)", "zadD(x)");
  line();
  for (i = -max; i <= max; ++i)
    printf("|%4d | %11d | %11d | %11d | %11d |\n", i, zadA(i), zadB(i), zadC(i), zadD(i));
  line();
  return 0;
}
