#include <stdio.h>
#include <stdlib.h>

#define check( p ) { if( p == NULL ) { printf( "Greska kod alokacije!\n" ); exit( 1 ); } }

int main( void )
{
	int m, n, i, red, stup, brRed, brStup, brojTakvih = 0;
	char **X, *Y;
	
	scanf( "%d%d", &m, &n );
	brRed = m; brStup = n;
	
	X = (char **) malloc( brRed * sizeof( char * ) ); check( X );
	for( red = 0; red < brRed; ++red )
	{
		X[red] = (char *) malloc( brStup * sizeof( char ) );
		check( X[red] );
	}

	for( red = 0; red < brRed; ++red )
	    for( stup = 0; stup < brStup; ++stup )
	        scanf( " %c", &X[red][stup] );
	        
	for( stup = 0; stup < brStup; ++stup )
	{
		int isOK = 1;
		for( red = 0; red < brRed && isOK; ++red )
			isOK = isOK && ( X[red][stup] == ( red % 3 == 0 ? '#' : '.' ) ); // ne da mi se jos vise od ovog raspisivati :)
			
		if( isOK )
		{
			++brojTakvih;
			for( red = 0; red < brRed; ++red )
			    if( X[red][stup] == '.' )
			        X[red][stup] = '*';
		}
	}
	
	Y = (char *) malloc( brojTakvih * sizeof( char ) ); check( Y );
	
	for( i = 0; i < brojTakvih; ++i )
	    Y[i] = '*';
	    
	printf( "\n\nX:\n" ); // za "ljepsi" ispis, ne treba

	for( red = 0; red < brRed; ++red, printf( "\n" ) )
	    for( stup = 0; stup < brStup; ++stup )
			printf( "%c ", X[red][stup] );
			
	printf( "\n\nY: " ); // za "ljepsi" ispis, ne treba

	for( i = 0; i < brojTakvih; ++i )
	    printf( "%c", Y[i] );

	free( Y );
	for( red = 0; red < brRed; ++red )
	    free( X[red] );
	free( X );

	return 0;
}
